icewm -- history of user-visible changes.  2022-02-23

Release icewm-2.9.6 released 2022-02-23
---------------------------------------

git shortlog -e -n -w80,6,8 2.9.5...2.9.6

Bert Gijsbers <gijsbers@science.uva.nl> (11):
      Lower a fullscreen window below the window which is to be activated.
      Start a new fullscreen client in the fullscreen layer for issue
        ice-wm/icewm#85.
      Fix format string in zh_CN to restore build and closes #639.
      Fix format string in zh_TW to restore build.
      Prioritize the thermal zones when showing CPU temperature.
      Share a single temperature object and free it on exit.
      Let CPUs share a single timer. Adjust to changes to taskBarCPUSamples.
      Support workspace names "next" and "prev" in icesh for issue #640.
      Update keys.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'

Grace Yu <grace.yu@excel-gits.com> (4):
      Translated using Weblate (Chinese (China) (zh_CN))
      Translated using Weblate (Chinese (China) (zh_CN))
      Translated using Weblate (Chinese (China) (zh_CN))
      Translated using Weblate (Chinese (Taiwan) (zh_TW))

Davide Aiello <davide.aiello@novilingulists.com> (3):
      Translated using Weblate (Italian)
      Translated using Weblate (Italian)
      Translated using Weblate (Italian)

Gemineo <vistatec@gemineo.de> (3):
      Translated using Weblate (German)
      Translated using Weblate (German)
      Translated using Weblate (German)

marcelo cripe <marcelocripe@gmail.com> (2):
      Translated using Weblate (Portuguese (Brazil))
      Translated using Weblate (Portuguese (Brazil))

Antonio Simón <antonio@trans-mission.com> (1):
      Translated using Weblate (Spanish)

Luiz Fernando Ranghetti <elchevive68@gmail.com> (1):
      Translated using Weblate (Portuguese (Brazil))


Release icewm-2.9.5 released 2022-01-20
---------------------------------------

git shortlog -e -n -w80,6,8 2.9.4...2.9.5

Bert Gijsbers <gijsbers@science.uva.nl> (16):
      Fix Arabic translation.
      On startup don't switch workspace to activate a fullscreen window.
      When a fullscreen disappears, update the taskbar layer.
      Fixes to prevent a lockup when activating a do-not-focus output-only
        window on a workspace where no focusable window exists.
      Remove inefficient management of fullscreen layer. Make
        TaskBarFullscreenAutoShow option more reliable.
      Cancel the DelayPointerFocus timer when the mouse leaves the window.
      Fix for taskbar on icewm restart when there is a fullscreen window. Fix
        for TaskBarAutoHide. Fix for focusing address bar.
      Fix OSS / APM confusion in some translations.
      Make taskbar unhide more reliable.
      Set the window type of desktop icons and of the dockapps container.
      Put a focused fullscreen window back to its normal layer, before
        activating another application.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Update pot files.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'
      Prepare 2.9.5 release

Eduard Bloch <blade@debian.org> (1):
      Work around trailers to zero-terminated strings

Ghassan <ghassan.alnajjar1984@gmail.com> (1):
      Translated using Weblate (Arabic)

Hugo Carvalho <hugokarvalho@hotmail.com> (1):
      Translated using Weblate (Portuguese)

Kukuh Syafaat <syafaatkukuh@gmail.com> (1):
      Translated using Weblate (Indonesian)

Mindaugas Baranauskas <opensuse.lietuviu.kalba@gmail.com> (1):
      Translated using Weblate (Lithuanian)

Paolo Za <zapaolo@email.it> (1):
      Translated using Weblate (Italian)

Rodrigo Macedo <rmsolucoeseminformatic4@gmail.com> (1):
      Translated using Weblate (Portuguese (Brazil))

Sarah Kriesch <ada.lovelace@gmx.de> (1):
      Translated using Weblate (German)


Release icewm-2.9.4 released 2021-12-30
---------------------------------------

git shortlog -e -n -w80,6,8 2.9.3...2.9.4

Bert Gijsbers <gijsbers@science.uva.nl> (17):
      Put the active window first in the list of switchable windows for issue
        #631.
      Show time of backtrace.
      Minimize the number of window restackings for issue #630.
      Support focus in subwindows of Globally Active Input applications, like
        full widescreen games for issue ice-wm/icewm#73.
      Minimized windows with startMinimized and ignoreActivationMessages require
        user intervention to become shown.
      Eliminate flicker when resizing frames which have a shape masked border,
        like CoolSteel and Illuminate-ice by enabling bit gravity.
      Improved workaround for 'feh' desktop backgrounds, where its pixmap has
        been marked persistent, for issue #627.
      Add children.
      Add icesh options +class and +Pid to extend the selection by class or PID.
      Set icewmbg background color as a pixmap to overcome limitations in picom
        and compton for issue #632.  Also retain a single background pixmap as a
        temporary resource in the X11 server when icewmbg exits.
      Lower desktop icons on startup.
      Fix miniicon stacking for when there is no other window.
      Make desktop refresh synchronized to slow it down a bit.
      Stack all desktop icons below a dedicated bottommost window.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'
      Prepare 2.9.4 release

Hugo Carvalho <hugokarvalho@hotmail.com> (1):
      Translated using Weblate (Portuguese)


Release icewm-2.9.3 released 2021-12-21
---------------------------------------

git shortlog -e -n -w80,6,8 2.9.2...2.9.3

Bert Gijsbers <gijsbers@science.uva.nl> (24):
      Fix vertical position of systray in taskbar to prevent background glitch
        for issue #626.
      Only repaint frame when it has borders.
      Initialize the system tray with a valid height for issue #626.  When the
        system tray changes height then start from a vertical position of 1 for
        issue #626.
      Revert commit 427547115d60d9b41860aa76b27cb8e805ed5d6a "Preferring DejaVu
        fonts for all purposes".
      Immediately create workspace buttons for more reliable taskbar relayouts.
      Add font macros for Xft fonts.
      Refresh task pane background on expose events.
      Support Unicode and non-Latin text in input fields and the address bar.
      Prevent compiler warnings.
      Denote the language.
      Initialize locale specific modifiers with XSetLocaleModifiers.
      Fix compilation without CONFIG_I18N.
      Fix for icesh maximize.
      Add a Tile submenu to the title bar menu for issue ice-wm/icewm#74.
      Update pot files.
      Add global 'ignorable' to not report errors for this unmapped client
        window.
      Postpone requesting focus for icewm internal windows until all create and
        map events have been processed.
      Set fFocusWin to nullptr when a frame is about to lose focus.
      Postpone granting focus to applications which use the Globally Active
        Input model, like wine, until all its events have been processed.
      Record when a client frame is unmapped, to not report further errors.
      Force the desktop background to be refreshed for 'feh' background pixmaps
        for issue #627.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'
      Prepare 2.9.3 release

David Medina <medipas@gmail.com> (2):
      Translated using Weblate (Catalan)
      Translated using Weblate (Catalan)

Eduard Bloch <blade@debian.org> (1):
      Preferring DejaVu fonts for all purposes

Ferdinand Galko <galko.ferdinand@gmail.com> (1):
      Translated using Weblate (Slovak)

Hugo Carvalho <hugokarvalho@hotmail.com> (1):
      Translated using Weblate (Portuguese)

Taras Panchenko <top39@ukr.net> (1):
      Translated using Weblate (Ukrainian)

Yasuhiko Kamata <belphegor@belbel.or.jp> (1):
      Translated using Weblate (Japanese)


Release icewm-2.9.2 released 2021-12-07
---------------------------------------

git shortlog -e -n -w80,6,8 2.9.1...2.9.2

Bert Gijsbers <gijsbers@science.uva.nl> (19):
      Fix for fullscreen wine programs for issue ice-wm/icewm#73.
      Fix against the flashing of title bar buttons when the window list is
        activated.
      Add class tokens.
      Include sys/wait.h for FreeBSD and internationalize the keyboard tooltip.
      Use class tokens to hide use of strtok.
      Internationalize the error messages for the dynamic menu.
      Add class YPidWaiter for asynchronous waiting for process termination.
      Prevent negative image positions in fillPixmap.
      Fix the drawing of ledclock pixmaps for some themes like "unusualscars" by
        means of clipping before calling fillPixmap.
      Update pot files.
      Raise the window list before mapping it.
      Prefer PictOpOver over PictOpSrc in drawPixmap for 24-bit displays.
      Delay font loading in APM until battery is detected.
      Add support for multiple clocks in different time zones.
      Improve explanation for TimeFormat and give an example.
      Postpone XFreeFontSet until names are no longer needed.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'
      Prepare 2.9.2 release

Taras Panchenko <top39@ukr.net> (2):
      Translated using Weblate (Russian)
      Translated using Weblate (Ukrainian)

Ferdinand Galko <galko.ferdinand@gmail.com> (1):
      Translated using Weblate (Slovak)

Yasuhiko Kamata <belphegor@belbel.or.jp> (1):
      Translated using Weblate (Japanese)


Release icewm-2.9.1 released 2021-12-02
---------------------------------------

git shortlog -e -n -w80,6,8 2.9.0...2.9.1

Bert Gijsbers <gijsbers@science.uva.nl> (14):
      When the keyboard layout changes due to external reasons and the taskbar
        has the keyboard applet, then reflect the new layout in the taskbar
        applet for issue #622. Make the keyboard applet display all of the
        output of `setxkbmap -query` in the tooltip for the applet. When the
        mouse is inside the keyboard applet, then post the tooltip.  Compress
        all the XMappingEvents to one single keyboard update event. Don't set
        the text on the taskbar collapse button when there is already a non-zero
        image for that button. Add leftToRight as an opposite of rightToLeft.
      Update potfiles.
      Fix workspace pane sizing for right-to-left locales.
      Fix taskbar collapse button for right-to-left locales.
      Ensure that the multiline tab spacing is two character positions.
      Fix multiline tooltips for right-to-left locales.
      Add tab separators to the CPU multiline status tooltip for two-column
        display.
      Replace "sans-serif" with "DejaVu Sans" for Xft fonts, because these
        support a wider range of characters, which improves support for
        languages with non-Latin scripts.
      Swap the columns in the about dialog for right-to-left locales.
      Fix the scaling of the taskbar background gradient for double height
        taskbar.
      Fix to focus wine and winecfg for issue #625, which improves commit
        3612d6e1397943e1cb009562d3cdedce21d5c63a.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'
      Prepare 2.9.1 release

Hugo Carvalho <hugokarvalho@hotmail.com> (1):
      Translated using Weblate (Portuguese)

marcelo cripe <marcelocripe@gmail.com> (1):
      Translated using Weblate (Portuguese (Brazil))


Release icewm-2.9.0 released 2021-11-24
---------------------------------------

git shortlog -e -n -w80,6,8 2.8.0...2.9.0

Bert Gijsbers <gijsbers@science.uva.nl> (82):
      Document the -T switch to select the taskbar in icesh for issue
        ice-wm/icewm#18.
      Fix the format string for "restart" in Ukrainian to fix the build.
      Fix for FreeBSD build.
      Print default locale in testlocale.
      Detect locale text direction.
      Only let a frame retake focus on an ungrab event when the manager still
        believes that frame should have focus. This fixes the flashing of title
        bar buttons when the window list window is popped up.
      Set the default background of the window list window to prevent undrawn
        holes at the bottom of the window when running with a compositor and
        alpha blending.
      Support more Right-To-Left languages.
      Don't kill internal windows.
      Restore build if CONFIG_I18N is undefined.
      Add a font cache to prevent repeatedly loading the same fonts, which also
        makes icewm a little faster on startup.
      Document the tracing on font loading.
      Add support for edge switching during drag and drop operations.
      Document drag and drop.
      Be resilient to font preferences being set to the empty string.
      Improve the handling of font loading failures. Improve the handling of
        setting "PreferFreetypeFonts" to false. Use the font "10x20" as the last
        resort font to fallback to, instead of the "fixed" font.
      Move all FriBidi stuff into a dedicated class YBidi.
      Move FONT macros to header fontmacro.h.
      Add new class YRange.
      Add rightToLeft global.
      Move screen-window intersection into YWindow coverage.
      Use new FONT macros from fontmacro.h. Remove minimizedWindowFontName.
      Detect Right-To-Left locales.
      Flush stdout after printing preferences.
      Reuse discarded miniicon positions.
      Take into account Right-To-Left when sorting task buttons, tray icons and
        workspace buttons.
      Prefer drawString over drawChars.
      Take into account Right-To-Left when sorting object buttons.
      Prefer wchar_t over YUchar.
      Pass findRemove data parameter by value for 'this'.
      Remove old FONT macros.
      Take into account Right-To-Left when ordering task bar subwindows.
      Take into account Right-To-Left when sorting systray icons.
      Improve font tracing.
      Improve vertical font positioning for the address bar.
      Improve ascent/descent detection for font sets. Improve fallback font
        pattern generation for font sets. Much faster optimal text length
        detection for width-limited text fields. Improve the Xft last resort
        backup font.
      Fix the horizontal scrollbar for the window list window.
      Detect right-to-left text.
      Drop YString and YLocaleString.
      Modernize casts.
      Remove old commented out code.
      Support right-to-left text. Handle width-limited text.
      Merge id.po.
      Make DejaVu the default backup font family for corefonts.
      Print the codeset.
      Detect UTF-8 locale and support multibyte to wide character conversions.
      Support right-to-left languages for corefonts when i18n is enabled. When
        codesets are missing in a fontset, then only search for extra fonts in
        the same font family, and only when i18n is enabled.
      Add logout icons to Logout submenu and closes ice-wm/icewm#69.
      Update minimum required cmake version to 3.2.
      Remove bidi from textWidth and fix offset.
      Add cancel-logout icon.
      Set the background of the bottom right corner of a scrolled view for issue
        620.
      Document the "font" argument to the "--trace" option.
      Postpone the redrawing of the frame borders when there is another expose
        event in the pipeline.
      Ignore empty resize events prematurely to reduce flickering while resizing
        windows in the CoolSteel theme.
      Fix the last entry in the themes menu for the default theme.
      Don't repaint the taskbar when it is collapsed.  Clear the taskbar window
        once more after repainting to prevent background artefacts when
        collapsing and expanding the taskbar in the CoolSteel theme.
      Swap titlebar button positions for right-to-left languages.
      Fix to prevent the dancing taskbar collapse button, when repeatedly
        collapsing and expanding the taskbar.
      Prefer to keep the system menu within the frame when opening it from the
        menu button in the titlebar.
      Fix for preferring to open the system menu within the frame.
      Accept -C,--copying without complaining.
      Fix column alignment in menu's for right-to-left languages.
      Only free cursor attributes when valid.
      Fixes for drawing partitioned right-to-left text when using multiple Xft
        fonts.
      Only swap title button pixmaps for right-to-left locales when they have
        the same size.
      Guard against all fonts not providing some glyph.
      Add XEMBED_EMBEDDED_NOTIFY and XEMBED_WINDOW_ACTIVATE.
      Guard against the condition that the taskbar doesn't have a frame.
      Give icewmbg an error handler to protect against destroyed windows.
      Increase the right margin of task buttons from one to two for
        right-to-left titles.
      Fix typo.
      Don't maximize buttons on height, because of artefacts in CrystalBlue.
      Center the inputline to accommodate fonts larger than the addressbar.
      Left-align right-to-left text if it fits within the size limitation.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Add new headers.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Fix typo.
      Merge remote-tracking branch 'upstream/icewm-1-4-BRANCH' into
        icewm-1-4-BRANCH
      Merge branch 'icewm-1-4-BRANCH'
      Prepare 2.9.0 release

Taras Panchenko <top39@ukr.net> (9):
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Ukrainian)
      Translated using Weblate (Russian)
      Translated using Weblate (Ukrainian)

marcelo cripe <marcelocripe@gmail.com> (3):
      Translated (Portuguese (Brazil))
      Translated using Weblate (Portuguese (Brazil))
      Translated using Weblate (Portuguese (Brazil))

TarasPanchenko <90216151+TarasPanchenko@users.noreply.github.com> (2):
      Update icewm-session.desktop (#616)
      Update icewm.desktop (#617)

Kukuh Syafaat <syafaatkukuh@gmail.com> (1):
      Translated using Weblate (Indonesian)

wallon <franckjl@hotmail.com> (1):
      Translated using Weblate (French)

